function [x] = lpc_resynth(r, a, wlen, wshft)

if rem(wlen,2)==1  
  wlen = wlen+1;
end
w     = hamming(wlen)';
nwin  = fix((length(r)-wlen+wshft)/wshft);

n = 0;
f = 1;

x  = zeros(size(r));
wm = zeros(size(r)); % Will store weights for normalization
while n+wlen<=length(x)
  r1 = r(n+(1:wlen)).*w;

  x(n+(1:wlen))  = x(n+(1:wlen)) + filter(1,a(f,:),r1);
  wm(n+(1:wlen)) = wm(n+(1:wlen)) + w;
    
  n = n+wshft;
  f = f+1;
end

x = x./wm;